#include "../include/base64.h"

#include <boost/beast.hpp>

std::string base64::decode(const std::string &val) {
  char buf[boost::beast::detail::base64::decoded_size(val.size())];
  int read =
      boost::beast::detail::base64::decode(buf, val.c_str(), val.size()).first;

  return std::string(buf, read);
}

std::vector<char> base64::decodeVector(const std::string &val) {
  char buf[boost::beast::detail::base64::decoded_size(val.size())];
  int read =
      boost::beast::detail::base64::decode(buf, val.c_str(), val.size()).first;

  std::vector<char> ret(buf, buf + read);
  return std::vector<char>(buf, buf + read);
}

std::string base64::encode(const std::string &val) {
  char buf[boost::beast::detail::base64::encoded_size(val.size())];
  int read = boost::beast::detail::base64::encode(buf, val.data(), val.size());

  return std::string(buf, read);
}

std::string base64::encodeVector(const std::vector<char> &val) {
  char buf[boost::beast::detail::base64::encoded_size(val.size())];
  int read = boost::beast::detail::base64::encode(buf, val.data(), val.size());

  return std::string(buf, read);
}
