#include <iostream>
#include <thread>

#include "../include/Config.h"
#include "../include/Server.h"
#include "../include/Sniffer.h"
#include "../include/UserManager.h"

using namespace std;

int main(int argc, char *argv[]) {
  // load config int namespace
  if (!Config::init("config.txt")) {
    cerr << "configuration could not be loaded properly" << endl;
    exit(EXIT_FAILURE);
  }

  const string interface = Config::getValue("interface");

  // check if userStorage is add specified location
  // if not create one
  UserManager::init(Config::getValue("userdatabase"));

  Sniffer *sniffer = new Sniffer(interface);
  thread snifferThread(&Sniffer::startSniffing, sniffer);

  try {
    io_service io_service;
    Server server(io_service);
    io_service.run();
  } catch (exception &e) {
    cerr << e.what() << endl;
  }

  snifferThread.join();
  delete (sniffer);
  return 0;
}
