#ifndef FILEMANAGERMOCK_H
#define FILEMANAGERMOCK_H

#include <gmock/gmock.h>
#include "../include/FileManager.h"

/**
 * @class FileManagerMock
 *
 * Gmock stub class for FileManager so you can test without writing and reading actual files.
 */
class FileManagerMock : public FileManager {
public:
  MOCK_METHOD(bool, openGetFile, (const std::string &filename, int &chunks), (override));
  MOCK_METHOD(bool, openPutFile, (const std::string &filename), (override));

  MOCK_METHOD(bool, isDownloading, (), (override));
  MOCK_METHOD(bool, isUploading, (), (override));

  MOCK_METHOD(void, cancelPut, (), (override));

  MOCK_METHOD(std::string, getGetBaseFileName, (), (override));
  MOCK_METHOD(std::string, getPutBaseFileName, (), (override));

  MOCK_METHOD(void, writePut, (const std::vector<char> &data), (override));
  MOCK_METHOD(std::vector<char>, readGet, (), (override));
};

#endif
