import QtQuick 2.12
import QtQuick.Controls 2.5
import QtQuick.Layouts 1.3

Page {
    width: 1280
    height: 470

    font.capitalization: Font.MixedCase

    Connections {
        target: _qmlHandler
        onMessage: {
            messagesLog.append(msg)
            messagesFlickable.contentY = messagesLog.height - messagesFlickable.height
        }
    }

    ColumnLayout {
        anchors.fill: parent

        Flickable {
            id: messagesFlickable
            flickableDirection: Flickable.VerticalFlick
            Layout.preferredHeight: 400
            Layout.preferredWidth: parent.width

            TextArea.flickable: TextArea {
                id: messagesLog
                readOnly: true
                selectByMouse: true
                wrapMode: TextArea.Wrap
                font.pointSize: 15
            }

            ScrollBar.vertical: ScrollBar {
            }
        }

        RowLayout {
            Layout.preferredHeight: 70
            Layout.preferredWidth: parent.width

            TextField {
                id: messagesInputField
                selectByMouse: true
                Layout.preferredWidth: 1060
                Layout.preferredHeight: parent.height
                placeholderText: "Enter message..."
                text: qsTr("")
                font.pixelSize: 20
                // @disable-check M222
                Keys.onReturnPressed: messagesSendButton.activate()
                // @disable-check M222
                Keys.onEnterPressed: messagesSendButton.activate()
            }

            Button {
                id: messagesSendButton
                Layout.preferredWidth: 180
                Layout.preferredHeight: parent.height
                text: qsTr("Send")

                // @disable-check M223
                onClicked: {
                    // @disable-check M222
                    messagesSendButton.activate()
                }

                enabled: messagesInputField.text != ""
                // @disable-check M222
                function activate() {
                    // @disable-check M223
                    if (messagesInputField.text != "") {
                        // @disable-check M222
                        _qmlHandler.onMessagesSendButton(
                                    messagesInputField.text)
                        messagesInputField.text = ""
                    }
                }
            }
        }
    }
}
