import QtQuick 2.12
import QtQuick.Controls 2.5
import QtQuick.Layouts 1.3

Page {
    width: 1280
    height: 470

    font.capitalization: Font.MixedCase

    Connections {
        target: _qmlHandler
        onReceivingListFile: {
            receivingFileList.append(fileName)
            receivingFlickable.contentY = receivingFileList.height - receivingFlickable.height
        }

        onReceivingClearFileList: {
            receivingFileList.text = ""
        }
    }

    ColumnLayout {
        anchors.fill: parent

        Flickable {
            id: receivingFlickable
            flickableDirection: Flickable.VerticalFlick
            Layout.preferredHeight: 400
            Layout.preferredWidth: parent.width

            TextArea.flickable: TextArea {
                selectByMouse: true
                readOnly: true
                id: receivingFileList
                wrapMode: TextArea.Wrap
                text: qsTr("")
                font.pointSize: 15
            }

            ScrollBar.vertical: ScrollBar {
            }
        }

        RowLayout {
            Layout.preferredWidth: parent.width
            Layout.preferredHeight: 70

            TextField {
                id: receivingFileNameField
                selectByMouse: true
                Layout.preferredWidth: 880
                Layout.preferredHeight: parent.height
                placeholderText: "Enter File Name to download..."
                text: qsTr("")
                font.pixelSize: 20
            }

            Button {
                id: receivingListFilesButton
                Layout.preferredWidth: 180
                Layout.preferredHeight: parent.height
                text: qsTr("List Files")

                // @disable-check M223
                onClicked: {
                    // @disable-check M223
                    _qmlHandler.onReceivingListFilesButton()
                }
            }

            Button {
                id: receivingGetFileButton
                Layout.preferredWidth: 180
                Layout.preferredHeight: parent.height
                text: qsTr("Download")

                enabled: receivingFileNameField.text != ""

                // @disable-check M223
                onClicked: {
                    // @disable-check M223
                    if (receivingFileNameField.text != "") {
                        // @disable-check M222
                        _qmlHandler.onReceivingGetFileButton(
                                    receivingFileNameField.text)
                        receivingFileNameField.text = ""
                    }
                }
            }
        }
    }
}
