import QtQuick 2.12
import QtQuick.Controls 2.5

ApplicationWindow {
    id: window
    visible: true
    width: 1280
    height: 720
    title: qsTr("Covert Channel - Control Panel")

    Connections {
        target: _qmlHandler
        onSettingsOpenSwitchServerPopup: {
            switchDialog.open()
        }
    }

    SwipeView {
        id: swipeView
        anchors.fill: parent
        currentIndex: header.currentIndex

        SendingForm {

        }

        ReceivingForm {

        }

        MessagesForm {

        }

        SettingsForm {

        }

        HelpForm {

        }
    }

    header: TabBar {
        id: header
        currentIndex: swipeView.currentIndex
        contentHeight: 50

        TabButton {
            text: qsTr("Sending")
        }

        TabButton {
            text: qsTr("Receiving")
        }

        TabButton {
            text: qsTr("Messages")
        }

        TabButton {
            text: qsTr("Settings")
        }

        TabButton {
            text: qsTr("Help")
        }
    }

    footer: FooterForm {

    }

    IpPopupForm {
        id: ipDialog
        x: Math.round((parent.width - width) / 2)
        y: Math.round((parent.height - height) / 2)
    }

    SwitchIpPopupForm {
        id: switchDialog
        x: Math.round((parent.width - width) / 2)
        y: Math.round((parent.height - height) / 2)
    }

    Component.onCompleted: {
      swipeView.interactive = false
      ipDialog.open()
    }
}
